KDE 4.9 PyKDE API Reference

- KDE's Python API

# KFind Class Reference

`from PyKDE4.kdeui import *`

Inherits: QObject
Subclasses: KReplace

## Detailed Description

A generic implementation of the "find" function.

Author:
  S.R.Haque <srhaque@iee.org>, David Faure <faure@kde.org>,

Arend van Beelen jr. <arend@auton.nl>

Detail:

This class includes prompt handling etc. Also provides some static functions which can be used to create custom behavior instead of using the class directly.

Example:

To use the class to implement a complete find feature:

In the slot connected to the find action, after using KFindDialog:

      // This creates a find-next-prompt dialog if needed.
      m_find = new KFind(pattern, options, this);

      // Connect highlight signal to code which handles highlighting
      // of found text.
      connect( m_find, SIGNAL( highlight( const QString &, int, int ) ),
              this, SLOT( slotHighlight( const QString &, int, int ) ) );
      // Connect findNext signal - called when pressing the button in the dialog
      connect( m_find, SIGNAL( findNext() ),
              this, SLOT( slotFindNext() ) );

If you are using a non-modal find dialog (the recommended new way in KDE-3.2), you should call right away m_find->closeFindNextDialog().

Then initialize the variables determining the "current position" (to the cursor, if the option FromCursor is set, to the beginning of the selection if the option SelectedText is set, and to the beginning of the document otherwise). Initialize the "end of search" variables as well (end of doc or end of selection). Swap begin and end if FindBackwards. Finally, call slotFindNext();

      void slotFindNext()
      {
          KFind.Result res = KFind.NoMatch;
          while ( res == KFind.NoMatch && <position not at end> ) {
              if ( m_find->needData() )
                  m_find->setData( <current text fragment> );

              // Let KFind inspect the text fragment, and display a dialog if a match is found
              res = m_find->find();

              if ( res == KFind.NoMatch ) {
                  <Move to the next text fragment, honoring the FindBackwards setting for the direction>
              }
          }

          if ( res == KFind.NoMatch ) // i.e. at end
              <Call either  m_find->displayFinalDialog(); m_find->deleteLater(); m_find = 0L;
               or           if ( m_find->shouldRestart() ) { reinit (w/o FromCursor) and call slotFindNext(); }
                            else { m_find->closeFindNextDialog(); }>
      }

Don't forget to delete m_find in the destructor of your class, unless you gave it a parent widget on construction.

This implementation allows to have a "Find Next" action, which resumes the search, even if the user closed the "Find Next" dialog.

A "Find Previous" action can simply switch temporarily the value of FindBackwards and call slotFindNext() - and reset the value afterwards.

## Enumerations

Options | { WholeWordsOnly, FromCursor, SelectedText, CaseSensitive, FindBackwards, RegularExpression, FindIncremental, MinimumUserOption }
Result | { NoMatch, Match }

## Signals

| dialogClosed ()
| findNext ()
| highlight (QString text, int matchingIndex, int matchedLength)
| highlight (int id, int matchingIndex, int matchedLength)
| optionsChanged ()

## Methods

| __init__ (self, QString pattern, long options, QWidget parent)
| __init__ (self, QString pattern, long options, QWidget parent, QWidget findDialog)
| closeFindNextDialog (self)
QWidget | dialogsParent (self)
| displayFinalDialog (self)
KFind.Result | find (self)
KDialog | findNextDialog (self, bool create=0)
int | index (self)
bool | needData (self)
int | numMatches (self)
long | options (self)
QWidget | parentWidget (self)
QString | pattern (self)
| resetCounts (self)
| setData (self, QString data, int startPos=-1)
| setData (self, int id, QString data, int startPos=-1)
| setOptions (self, long options)
| setPattern (self, QString pattern)
bool | shouldRestart (self, bool forceAsking=0, bool showNumMatches=1)
bool | validateMatch (self, QString text, int index, int matchedlength)

## Static Methods

int, int matchedlength | find (QString text, QString pattern, int index, long options)
int, int matchedlength | find (QString text, QRegExp pattern, int index, long options)

## Signal Documentation

dialogClosed | ( |  | ) |

Emitted when the 'find next' dialog is being closed. Some apps might want to remove the highlighted text when this happens. Apps without support for "Find Next" can also do m_find->deleteLater() to terminate the find operation.

Signal syntax:
  `QObject.connect(source, SIGNAL("dialogClosed()"), target_slot)`

findNext | ( |  | ) |

Signal syntax:
  `QObject.connect(source, SIGNAL("findNext()"), target_slot)`

highlight | ( | QString | text,
|  | int | matchingIndex,
|  | int | matchedLength
| ) |  |  |

Connect to this signal to implement highlighting of found text during the find operation.

Use this signal if you've set your data with setData(id, text), otherwise use the signal with highlight(text, matchingIndex, matchedLength).

WARNING: If you're using the FindIncremental option, the id argument passed by this signal is not necessarily the id of the data last set through setData(), but can also be of an earlier set data block.

See also:
  setData()

Signal syntax:
  `QObject.connect(source, SIGNAL("highlight(const QString&, int, int)"), target_slot)`

highlight | ( | int | id,
|  | int | matchingIndex,
|  | int | matchedLength
| ) |  |  |

Connect to this signal to implement highlighting of found text during the find operation.

Use this signal if you've set your data with setData(id, text), otherwise use the signal with highlight(text, matchingIndex, matchedLength).

WARNING: If you're using the FindIncremental option, the id argument passed by this signal is not necessarily the id of the data last set through setData(), but can also be of an earlier set data block.

See also:
  setData()

Signal syntax:
  `QObject.connect(source, SIGNAL("highlight(int, int, int)"), target_slot)`

optionsChanged | ( |  | ) |

Emitted when the options have changed. This can happen e.g. with "Replace All", or if our 'find next' dialog gets a "find previous" one day.

Signal syntax:
  `QObject.connect(source, SIGNAL("optionsChanged()"), target_slot)`

## Method Documentation

__init__ | ( | self, |
|  | QString | pattern,
|  | long | options,
|  | QWidget | parent
| ) |  |  |

Only use this constructor if you don't use KFindDialog, or if you use it as a modal dialog.

__init__ | ( | self, |
|  | QString | pattern,
|  | long | options,
|  | QWidget | parent,
|  | QWidget | findDialog
| ) |  |  |

This is the recommended constructor if you also use KFindDialog (non-modal). You should pass the pointer to it here, so that when a message box appears it has the right parent. Don't worry about deletion, KFind will notice if the find dialog is closed.

closeFindNextDialog | ( |  | self ) |

Close the "find next?" dialog. The application should do this when the last match was hit. If the application deletes the KFind, then "find previous" won't be possible anymore.

IMPORTANT: you should also call this if you are using a non-modal find dialog, to tell KFind not to pop up its own dialog.

QWidget dialogsParent | ( |  | self ) |

displayFinalDialog | ( |  | self ) |

Displays the final dialog saying "no match was found", if that was the case. Call either this or shouldRestart().

KFind.Result find | ( |  | self ) |

Search the given string, and returns whether a match was found. If one is, the length of the string matched is also returned.

A performance optimised version of the function is provided for use with regular expressions.

Parameters:

  | text | The string to search.
  | pattern | The pattern to look for.
  | index | The starting index into the string.
  | options | The options to use.
  | matchedlength | The length of the string that was matched

Returns:
  The index at which a match was found, or -1 if no match was found.

KDialog findNextDialog | ( | self, |
|  | bool | create=0
| ) |  |  |

Return (or create) the dialog that shows the "find next?" prompt. Usually you don't need to call this. One case where it can be useful, is when the user selects the "Find" menu item while a find operation is under way. In that case, the program may want to call setActiveWindow() on that dialog.

int index | ( |  | self ) |

Returns:
  the current matching index ( or -1 ). Same as the matchingIndex parameter passed to highlight. You usually don't need to use this, except maybe when updating the current data, so you need to call setData( newData, index() ).

bool needData | ( |  | self ) |

Returns:
  true if the application must supply a new text fragment It also means the last call returned "NoMatch". But by storing this here the application doesn't have to store it in a member variable (between calls to slotFindNext()).

int numMatches | ( |  | self ) |

Return the number of matches found (i.e. the number of times the highlight signal was emitted). If 0, can be used in a dialog box to tell the user "no match was found". The final dialog does so already, unless you used setDisplayFinalDialog(false).

long options | ( |  | self ) |

Return the current options.

Warning: this is usually the same value as the one passed to the constructor, but options might change _during_ the replace operation: e.g. the "All" button resets the PromptOnReplace flag.

See also:
  KFind.Options

QWidget parentWidget | ( |  | self ) |

QString pattern | ( |  | self ) |

Returns:
  the pattern we're currently looking for

resetCounts | ( |  | self ) |

Call this to reset the numMatches count (and the numReplacements count for a KReplace). Can be useful if reusing the same KReplace for different operations, or when restarting from the beginning of the document.

setData | ( | self, |
|  | QString | data,
|  | int | startPos=-1
| ) |  |  |

Call this when needData returns true, before calling find(). The use of ID's is especially useful if you're using the FindIncremental option.

Parameters:

  | id | the id of the text fragment
  | data | the text fragment (line)
  | startPos | if set, the index at which the search should start. This is only necessary for the very first call to setData usually, for the 'find in selection' feature. A value of -1 (the default value) means "process all the data", i.e. either 0 or data.length()-1 depending on FindBackwards.

setData | ( | self, |
|  | int | id,
|  | QString | data,
|  | int | startPos=-1
| ) |  |  |

Call this when needData returns true, before calling find(). The use of ID's is especially useful if you're using the FindIncremental option.

Parameters:

  | id | the id of the text fragment
  | data | the text fragment (line)
  | startPos | if set, the index at which the search should start. This is only necessary for the very first call to setData usually, for the 'find in selection' feature. A value of -1 (the default value) means "process all the data", i.e. either 0 or data.length()-1 depending on FindBackwards.

setOptions | ( | self, |
|  | long | options
| ) |  |  |

Set new options. Usually this is used for setting or clearing the FindBackwards options.

See also:
  KFind.Options

setPattern | ( | self, |
|  | QString | pattern
| ) |  |  |

Change the pattern we're looking for

bool shouldRestart | ( | self, |
|  | bool | forceAsking=0,
|  | bool | showNumMatches=1
| ) |  |  |

Returns true if we should restart the search from scratch. Can ask the user, or return false (if we already searched the whole document).

Parameters:

  | forceAsking | set to true if the user modified the document during the search. In that case it makes sense to restart the search again.
  | showNumMatches | set to true if the dialog should show the number of matches. Set to false if the application provides a "find previous" action, in which case the match count will be erroneous when hitting the end, and we could even be hitting the beginning of the document (so not all matches have even been seen).

bool validateMatch | ( | self, |
|  | QString | text,
|  | int | index,
|  | int | matchedlength
| ) |  |  |

Virtual method, which allows applications to add extra checks for validating a candidate match. It's only necessary to reimplement this if the find dialog extension has been used to provide additional criterias.

Parameters:

  | text | The current text fragment
  | index | The starting index where the candidate match was found
  | matchedlength | The length of the candidate match

## Static Method Documentation

int, int matchedlength find | ( | QString | text,
|  | QString | pattern,
|  | int | index,
|  | long | options
| ) |  |  |

Search the given string, and returns whether a match was found. If one is, the length of the string matched is also returned.

A performance optimised version of the function is provided for use with regular expressions.

Parameters:

  | text | The string to search.
  | pattern | The pattern to look for.
  | index | The starting index into the string.
  | options | The options to use.
  | matchedlength | The length of the string that was matched

Returns:
  The index at which a match was found, or -1 if no match was found.

int, int matchedlength find | ( | QString | text,
|  | QRegExp | pattern,
|  | int | index,
|  | long | options
| ) |  |  |

Search the given string, and returns whether a match was found. If one is, the length of the string matched is also returned.

A performance optimised version of the function is provided for use with regular expressions.

Parameters:

  | text | The string to search.
  | pattern | The pattern to look for.
  | index | The starting index into the string.
  | options | The options to use.
  | matchedlength | The length of the string that was matched

Returns:
  The index at which a match was found, or -1 if no match was found.

## Enumeration Documentation

Options

Enumerator:

  PromptOnReplace = 256 |
  BackReference = 512 |

Result

Enumerator:

  NoMatch |
  Match |